QuantLib: DefaultLossModel Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.6

- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Protected Attributes | Friends | List of all members
DefaultLossModel Class Referenceabstract

`#include <ql/experimental/credit/defaultlossmodel.hpp>`

Inheritance diagram for DefaultLossModel:
[legend]

## Protected Member Functions
Statistics
virtual Real | expectedTrancheLoss (const Date &d) const
virtual Probability | probOverLoss (const Date &d, Real lossFraction) const
virtual Real | percentile (const Date &d, Real percentile) const
| Value at Risk given a default loss percentile.
virtual Real | expectedShortfall (const Date &d, Real percentile) const
| Expected shortfall given a default loss percentile.
virtual Disposable< std::vector< Real > > | splitVaRLevel (const Date &d, Real loss) const
| Associated VaR fraction to each counterparty.
virtual Disposable< std::vector< Real > > | splitESFLevel (const Date &d, Real loss) const
| Associated ESF fraction to each counterparty.
virtual Disposable< std::map< Real, Probability > > | lossDistribution (const Date &) const
| Full loss distribution.
virtual Real | densityTrancheLoss (const Date &d, Real lossFraction) const
| Probability density of a given loss fraction of the basket notional.
virtual Disposable< std::vector< Probability > > | probsBeingNthEvent (Size n, const Date &d) const
virtual Real | defaultCorrelation (const Date &d, Size iName, Size jName) const
| Pearsons' default probability correlation.
virtual Probability | probAtLeastNEvents (Size n, const Date &d) const
virtual Real | expectedRecovery (const Date &, Size iName, const DefaultProbKey &) const

## Protected Attributes
RelinkableHandle< Basket > | basket_

## Friends
class | Basket

## Additional Inherited Members
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()

## Detailed Description

Default loss model interface definition. Allows communication between the basket and specific algorithms. Intended to hold any kind of portfolio joint loss, latent models, top-down,....

An inconvenience of this design as opposed to the full arguments/results is that when pricing several derivatives instruments on the same basket not all the pricing engines would point to the same loss model; thus when pricing a set of such instruments there might be some switching on the basket loss models, which might require recalculations (of the basket) or not depending on the pricing order.

## Member Function Documentation

virtual Probability probOverLoss | ( | const Date & | d,
|  | Real | lossFraction
| ) |  | const
| protectedvirtual

Probability of the tranche losing the same or more than the fractional amount given.

Parameters

  lossFraction | A fraction of losses over the tranche notional (not the portfolio)

Reimplemented in SaddlePointLossModel< CP >, and GaussianLHPLossModel.

virtual Disposable<std::vector<Probability> > probsBeingNthEvent | ( | Size | n,
|  | const Date & | d
| ) |  | const
| protectedvirtual

Probabilities for each of the (remaining) basket elements in the pool to have defaulted by time d and at the same time be the Nth defaulting name to default in the basket. This method is oriented to default order dependent portfolio pricing (e.g. NTDs) The the probabilities ordering in the vector coincides with the pool order.

Reimplemented in RandomLM< derivedRandomLM, copulaPolicy, USNG >, RandomLM< RandomDefaultLM, copulaPolicy, USNG >, and RandomLM< RandomLossLM, copulaPolicy, USNG >.

virtual Probability probAtLeastNEvents | ( | Size | n,
|  | const Date & | d
| ) |  | const
| protectedvirtual

Returns the probaility of having a given or larger number of defaults in the basket portfolio at a given time.

Reimplemented in RandomLM< derivedRandomLM, copulaPolicy, USNG >, RandomLM< RandomDefaultLM, copulaPolicy, USNG >, RandomLM< RandomLossLM, copulaPolicy, USNG >, and ConstantLossModel< copulaPolicy >.

virtual Real expectedRecovery | ( | const Date & | ,
|  | Size | iName,
|  | const DefaultProbKey & |
| ) |  | const
| protectedvirtual

Expected RR for name conditinal to default by that date.

Reimplemented in RandomDefaultLM< copulaPolicy, USNG >, ConstantLossModel< copulaPolicy >, and GaussianLHPLossModel.